// #autoload
// #name = LobbyTab
// #version = 1.1
// #date = April 05, 2002
// #author = Misanthropic aka. EXoCiDe
// #warrior = Misanthropic
// #email = exocide@barrysworld.com
// #web = http://exocide.vsn.nu
// #description = Adds a tab for the game Lobby as if it were another community item, allowing you to access chat, browser, email etc. while in a game.
// #credit = PointDestruction for getting me into GUI mods in the first place :)
// #credit = Red Dog Dragon for suggesting 1.1
// #readme = LobbyTab_ReadMe.txt


package LobbyTab {

	function LoadingGui::onWake(%this)
	{
		if(!$InGame){
			$InGame = true;
		}
		if(!$LobbyInMenu){
			LaunchToolbarMenu.insertSeparatorAt(0);
			LaunchToolbarMenu.insertItemAt(0, 13, "LOBBY");
			$LobbyInMenu = true;
		}
		parent::onWake(%this);	
	}

	function LobbyGui::onWake(%this){
		parent::onWake(%this);
		Canvas.pushDialog(LaunchToolbarDlg);
		if(!$LobbyTabbed){
			LaunchTabView.viewTab("LOBBY", LobbyGui, 13);
			$LobbyTabbed = true;
		}
	}

	function LaunchToolbarMenu::onSelect(%this, %id, %text){
		parent::onSelect(%this, %id, %text);
		if(%id == 13 && $InGame){
			LaunchTabView.viewTab("LOBBY", LobbyGui, 13);
		}
	}

	function JoinGame(%address){
		if($InGame && (%address $= $CurrentGame)){
			MessageBoxOK("ERROR", "You are already in that game.");
		}
		else if($InGame){
			Disconnect();
			$CurrentGame = %address;
			parent::JoinGame(%address);
		}
		else {
			$CurrentGame = %address;
			parent::JoinGame(%address);
		}
	}

	function DisconnectedCleanup(){
		parent::DisconnectedCleanup();

		$InGame = false;
		$CurrentGame = false;

		if($LobbyInMenu){
			LaunchToolbarMenu.removeItemAt(0);
			LaunchToolbarMenu.removeSeparatorAt(0);
			$LobbyInMenu = false;
		}
		if($LobbyTabbed){
			LaunchTabView.closeTab(LobbyGui, 13);
			$LobbyTabbed = false;
		}
	}
};

activatePackage(LobbyTab);